﻿
init python:
    renpy.music.register_channel("music2", mixer="music2", loop=False)
    renpy.music.register_channel("music3", mixer="music3", loop=False)
    class music_control_class:
        def __init__(self):
            self.channels = ['music', 'music2', 'music3']
            self.channel = 'music'

            self.is_open = True
        def change_channel(self, channel):
            self.channel = channel
        def open(self):
            if self.is_open:
                self.is_open = False
            else:
                self.is_open = True
        def name_format(self):
            r = renpy.music.get_playing(channel=self.channel).split("/")[-1]
            rr = r.split(".")[0]
            rrr = rr.split("_-_")
            return rrr
        def get_time(self, ttl = False):
            if ttl:
                i, f = divmod(renpy.music.get_duration(channel=self.channel), 1)
            else:
                i, f = divmod(renpy.music.get_pos(channel=self.channel), 1)
            i = int(i)
            m, s = divmod(i, 60)
            h, m = divmod(m, 60)
            return "{:02}:{:02}.{:02}".format(m, s, int(f*100))

define music_control = music_control_class()

screen music_controls(m = music_control):
    default p = None
    style_prefix "musiccontrols"
    drag:
        frame:
            
            if m.is_open:
                button:
                    at mc_btn
                    add "music_controls/maximize.png"
                    action Function(m.open)
            else:
                xsize 600
                vbox:
                    align .5,.5
                    spacing 5
                    timer .1 repeat True action SetScreenVariable("p",p)
                    if isinstance(renpy.music.is_playing(channel=m.channel), int):
                        if renpy.music.get_pos(channel=m.channel):
                            $ p = renpy.music.get_pos(channel=m.channel)
                            vbox:
                                align .5,.5
                                text m.name_format()[1] size 20
                                text "by: {}".format(m.name_format()[0]) size 20
                                text "{} / {}".format(m.get_time(), m.get_time(True))
                        else:
                            text _("stopped") size 25
                        if p:
                            bar value StaticValue(value=p, range=renpy.music.get_duration(channel=m.channel)) xysize 500,40 left_bar "#fff" align .5,.5
                    bar value MixerValue(m.channel) xysize 500,20  align .5,.5
                    hbox:
                        align .5,.5
                        spacing 4
                        button:
                            at mc_btn
                            add "music_controls/play.png"
                            action ToggleMute(m.channel)
                        button:
                            at mc_btn
                            add "music_controls/pause.png"
                            action PauseAudio(m.channel, value="toggle")
                        button:
                            at mc_btn
                            add "music_controls/power.png"
                            action Stop(m.channel)
                        button:
                            at mc_btn
                            add "music_controls/settings.png"
                            action ToggleScreen("music_controls_settings")
                        button:
                            at mc_btn
                            add "music_controls/minimize.png"
                            action Function(m.open)


screen music_controls_settings(m = music_control):
    style_prefix "musiccontrols"
    drag:
        align .5,.5
        frame:
            vbox:
                spacing 4
                text _("Choose your channel")
                for i in m.channels:
                    button:
                        at mc_btn
                        background "#000a" padding (10,10)
                        text i
                        action Function(m.change_channel, i), Hide("music_controls_settings")
                button:
                    at mc_btn
                    background "#000a"
                    text _("Close")
                    action Hide("music_controls_settings")

transform mc_btn:
    on idle:
        ease .2 additive 0 zoom 1
    on hover:
        ease .2 additive .2 zoom 1.4
    on selected:
        ease .2 additive .6 zoom 1.4

style musiccontrols_button:
    align (.5,.5)

style musiccontrols_frame:
    background "#000a" padding (10,10)
style musiccontrols_text:
    align (.5,.5)
    size 30
init python:
    config.overlay_screens.append("music_controls")


label music_controls_test:
    show image "bg.jpg"
    $ music_control.change_channel('music')
    "Setting the channel to music"
    play music "music_controls/Apoxode_-_Music Through Love ft. Kara Square.ogg"
    pause
    play music "music_controls/cuajitoben_-_En Shenandoah.ogg"
    pause
    
    play music "music_controls/mindmapthat_-_Where the Moon Shines Bright 1.ogg"
    pause
    $ music_control.change_channel('music2')
    "Changing channel"
    stop music
    "stopping the music channel"
    $ renpy.play("music_controls/mindmapthat_-_Where the Moon Shines Bright 1.ogg", channel="music2")
    "Playing it on the music2 channel"
    pause

